
/*----------------------------------------------------------
---*\
 |  SINE.C - Creates a .ASM data file containing sine values   |
 |               from 0 to 90 degrees.  This file is suitable  |
 |               for creating a custom Windows resource.       |
\*----------------------------------------------------------
---*/

#include "stdio.h"
#include "math.h"

char achFileHeader[] =
     ";\n"
     "; Sine/Cosine Data Table\n"
     ";\n"
     ";\n"
     "; Table of Sine values from 0 to 90 degrees\n"
     ";\n"
     "SINDATA segment public\n";

char achFileFooter[] =
     "\n"
     "SINDATA ends\n"
     "END\n";


main()
    {
    double dbPI  = 3.1415926536;
    double dbRad;
    FILE   * fp;
    int    iAngle;
    int    iSin;

    if (!(fp = fopen("sinedata.asm", "w")))
        {
        printf("Can't create sinedata.asm.\n");
        exit(1);
        }

    fprintf (fp, achFileHeader);
    fprintf (fp, "DW ");

    for (iAngle = 0; iAngle <= 90; iAngle++)
        {
        dbRad = (((double)iAngle) * dbPI) / 180.0;
        iSin = sin(dbRad) * 10000.0 + 0.5;
        fprintf(fp, " %5d", iSin);

        if (iAngle % 8 == 7)
            fprintf (fp, "\nDW ");
        else if (iAngle != 90)
            fprintf (fp, ",");
        }

    fprintf(fp, achFileFooter);

    fclose(fp);
    }

